// ASEC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "windows.h"

#define NUM_VERTEX			"*MESH_NUMVERTEX"
#define NUM_FACE			"*MESH_NUMFACES"
#define NUM_TVERTEX			"*MESH_NUMTVERTEX"
#define NUM_TFACE			"*MESH_NUMTVFACES"
#define VERTEX_LIST			"*MESH_VERTEX_LIST"
#define VERTEX				"*MESH_VERTEX"
#define FACE_LIST			"*MESH_FACE_LIST"
#define FACE				"*MESH_FACE"
#define NORMALS				"*MESH_NORMALS"
#define FACE_NORMAL			"*MESH_FACENORMAL"
#define NVERTEX				"*MESH_VERTEXNORMAL"
#define TVERTEX				"*MESH_TVERT"
#define TFACE				"*MESH_TFACE"
#define TEXTURE				"*BITMAP"
#define UTILE				"*UVW_U_TILING"
#define VTILE				"*UVW_V_TILING"
#define UOFFSET				"*UVW_U_OFFSET"
#define VOFFSET				"*UVW_V_OFFSET"
#define GEOMOBJECT			"*GEOMOBJECT"
#define NODENAME			"*NODE_NAME"
#define WIREFRAMECOLOR		"*WIREFRAME_COLOR"
#define GROUP				"*GROUP"
#define MAT_COUNT			"*MATERIAL_COUNT"
#define MAT_MATERIAL		"*MATERIAL"
#define MAT_REFERENCE		"*MATERIAL_REF"
#define MAT_SUBMATERIAL		"*SUBMATERIAL"
#define MAT_NUMSUBMTL		"*NUMSUBMTLS"
#define MAT_AMBIENT			"*MATERIAL_AMBIENT"
#define MAT_DIFFUSE			"*MATERIAL_DIFFUSE"
#define MAT_SPECULAR		"*MATERIAL_SPECULAR"
#define MESH_MTLID			"*MESH_MTLID"


static LONG	object_count = 0;
static LONG mat_count = 0;
static LONG face_count = 0;


void aseParse(FILE *s)
{
	char data[255];

	// get file size
	fseek(s, 0, SEEK_END);
	LONG fs = ftell(s);

	printf("read file(%d bytes)...\n\n", fs);

	rewind(s);


	while(!feof(s))
	{
		fscanf(s, "%s", data);

		if (!strcmp(data, MAT_MATERIAL))
		{
			mat_count++;
		}
		else if (!strcmp(data, GEOMOBJECT))
		{
			object_count++;
		}
		else if (!strcmp(data, NODENAME))
		{
			char buf[32];
			
			fscanf(s, " \"%s", buf);
			
			// to remove "
			buf[strlen(buf)-1] = NULL;
			printf("object name: %s (ID: %d)\n", buf, object_count);
		}
		else if (!strcmp(data, NUM_VERTEX))
		{
			short v;

			fscanf(s, "%d", &v);

			printf("* total vertices: %d\n", v);
		}
		else if (!strcmp(data, NUM_FACE))
		{
			short v;

			fscanf(s, "%d", &v);

			printf("* total faces: %d\n", v);
		}
		// read wire-frame color
		else if (!strcmp(data, WIREFRAMECOLOR))
		{
			float f[3];
			
			fscanf(s, "%f %f %f", &f[0], &f[1], &f[2]);

			printf("* wire frame color: %f, %f, %f\n", f[0], f[1], f[2]);
		}
		// read vertex
		else if (!strcmp(data, VERTEX))
		{
			short v;
			float f[3];
			
			fscanf(s, "%d", &v);
			fscanf(s, "%f %f %f", &f[0], &f[1], &f[2]);

			printf("* vtx %d: %f, %f, %f\n", v, f[0], f[1], f[2]);
		}
		// read face
		else if (!strcmp (data, FACE))
		{
			short v;
			short vv[3];
			
			face_count++;
			
			fscanf(s, "%d:", &v);
			fscanf(s, " A:\t%d B:\t%d C:\t%d", &vv[0], &vv[1], &vv[2]);

			printf("* face %d: %d, %d, %d\n", v, vv[0], vv[1], vv[2]);
		}
	}
}


void aseConv(char* fn)
{
	FILE *s;

	if (!(s = fopen(fn, "r")))
	{
		// file not found, bummer
		printf("# %s not found!\n", fn);
		return;
	}

	aseParse(s);

	fclose(s);
}

void main(int argc, char* argv[])
{
	printf("ASEC - ASE Converter\n");

	if (argc < 2)
		return;

	aseConv(argv[1]);
}

