

/*
** Binary File Manager, 2000-2001, Jinhong Kim, cheriz@empal.com
** Tested at Warning Level 4
*/


#ifndef __BINARYFILEMANAGER__
#define __BINARYFILEMANAGER__


#pragma message (__FILE__ ", BFM, cheriz@empal.com, Rev.2")



#include <windows.h>


typedef unsigned __int8		BFMINT8, *PBFMINT8;
typedef unsigned __int16	BFMINT16, *PBFMINT16;
typedef unsigned __int32	BFMINT32, *PBFMINT32;
typedef unsigned __int64	BFMINT64, *PBFMINT64;

#define BFMINT8_MAX			(BFMINT8)0xFF
#define BFMINT16_MAX		(BFMINT16)0xFFFF
#define BFMINT32_MAX		(BFMINT32)0xFFFFFFFF
#define BFMINT64_MAX		(BFMINT64)0xFFFFFFFFFFFFFFFF

typedef float				BFMFLOAT32, *PBFMFLOAT32;
typedef double				BFMFLOAT64, *PBFMFLOAT64;
typedef long double			BFMFLOAT80, *PBFMFLOAT80;

typedef unsigned __int8		BFMSIGNATURE, *PBFMSIGNATURE;



#define MAX_BF_NAME	32



class	BFManager
{
private:
	char		file_name[MAX_BF_NAME];
	HANDLE		hFile;
	BFMINT16	err;
	BFMINT32	file_size;
	BFMINT8*	buf_ptr;
	BFMINT8*	buf_cur_ptr;
	BFMINT8*	buf_last_ptr;
	BOOL		bDMA;

public:
	BFManager();
	BFManager(char *fn);
	~BFManager();

	
	void Init(char *fname);
	void InitDirectMemoryAccess(char* buf);

	BFMINT16 OpenToRead();
	BFMINT16 OpenToWrite();
	void Close();

	BFMINT16 ReadSig(BFMSIGNATURE *v);
	BFMINT16 ReadInt8(BFMINT8 *v, BFMINT32 len);
	BFMINT16 ReadInt16(BFMINT16 *v, BFMINT32 len);
	BFMINT16 ReadInt32(BFMINT32 *v, BFMINT32 len);
	BFMINT16 ReadInt64(BFMINT64 *v, BFMINT32 len);
	BFMINT16 ReadFloat32(BFMFLOAT32 *v, BFMINT32 len);
	BFMINT16 ReadFloat64(BFMFLOAT64 *v, BFMINT32 len);
	BFMINT16 ReadFloat80(BFMFLOAT80 *v, BFMINT32 len);
	
	BFMINT16 WriteSig(BFMSIGNATURE v);
	BFMINT16 WriteInt8(BFMINT8 *v, BFMINT32 len);
	BFMINT16 WriteInt16(BFMINT16 *v, BFMINT32 len);
	BFMINT16 WriteInt32(BFMINT32 *v, BFMINT32 len);
	BFMINT16 WriteInt64(BFMINT64 *v, BFMINT32 len);
	BFMINT16 WriteFloat32(BFMFLOAT32 *v, BFMINT32 len);
	BFMINT16 WriteFloat64(BFMFLOAT64 *v, BFMINT32 len);
	BFMINT16 WriteFloat80(BFMFLOAT80 *v, BFMINT32 len);
	
	BFMINT16 Seek(BFMINT32 pos);
	BFMINT16 Current(BFMINT32 *pos);
	BFMINT16 Skip(BFMINT32 len);
	BFMINT16 Rewind();
	
	BFMINT16 WriteSeek(BFMINT32 pos);
	BFMINT16 WriteCurrent(BFMINT32 *pos);
	BFMINT16 WriteSkip(BFMINT32 len);
	BFMINT16 WriteRewind();
	
	BFMINT16 Err();
	BFMINT32 GetFSize();
};



#endif

